



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>STM32F4_TIM基本延时（计数原理）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">STM32F4_TIM基本延时（计数原理）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 14:04:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>Ⅰ、</strong><strong>概述</strong></p>
<p>STM32的TIM定时器分为三类：基本定时器、通用定时器和高级定时器。从分类来看就知道STM32的定时器功能是非常强大的，但是，功能强大了，软件配置定时器就相对复杂多了。很多初学者甚至工作了一段时间的人都不知道STM32<strong>最基本的计数原理</strong>。</p>
<p>虽然STM32定时器功能强大，也分了三类，但他们最基本的计数部分原理都是一样的，也就是我们常常使用的延时（或定时）多少us、ms等。</p>
<p>接下来我会<strong>讲述关于STM32最基本的计数原理</strong>，详细讲述如何做到(配置)<strong>计数1us的延时</strong>，并提供实例代码供大家参考学习。</p>
<p>关于本文的更多详情请往下看。</p>
<p><strong>Ⅱ、</strong><strong>实例工程下载</strong></p>
<p>笔者针对于初学者提供的例程都是去掉了许多不必要的功能，精简了官方的代码，对初学者一看就明白，以简单明了的工程供大家学习。</p>
<p>笔者提供的实例工程都是在板子上经过多次测试并没有问题才上传至360云盘，欢迎下载测试、参照学习。</p>
<p>提供下载的软件工程是STM32F417的，但F4其他型号也适用（适用F4其他型号： 关注微信，回复&ldquo;修改型号&rdquo;）。</p>
<p>STM32F4_TIM基本延时（1us延时基准）实例：</p>
<p><a href="https://yunpan.cn/cB3hC8amiyq2C" rel="external nofollow noreferrer">https://yunpan.cn/cB3hC8amiyq2C</a>&nbsp;&nbsp;访问密码 5224</p>
<p>感兴趣的朋友研究下面实例&ldquo;定时中断&rdquo;</p>
<p>STM32F4_TIM基本定时（1ms定时中断）实例：</p>
<p><a href="https://yunpan.cn/cB3CyILIXeaFc" rel="external nofollow noreferrer">https://yunpan.cn/cB3CyILIXeaFc</a>&nbsp;&nbsp;访问密码 0ad9</p>
<p>STM32F4资料：</p>
<p><a href="https://yunpan.cn/cR2pxqF5x2d9c" rel="external nofollow noreferrer">https://yunpan.cn/cR2pxqF5x2d9c</a>&nbsp;&nbsp;访问密码 53e7</p>
<p><strong>Ⅲ、</strong><strong>TIM计数原理描述</strong></p>
<p>定时器可以简单的理解为：由计数时钟（系统时钟或外部时钟）一个一个计数，直到计数至我们设定的值，这个时候产生一个事件，告诉我们计数到了。</p>
<p>上面简单的描述懂了之后就是需要理解它们每一步骤的细节，比如：提供的时钟频率是多少、分频是多少等。</p>
<p><strong>基本TIM框图:</strong></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/957778/201607/957778-20160708115812780-1801695170.png" /></p>
<p><strong>通用TIM框图:</strong></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/957778/201607/957778-20160708115821577-292560632.png" /></p>
<p>上面两图截取&ldquo;STM32F4x5、x7参考手册&rdquo;建议下载手册参看。</p>
<p>从上面两个TIM框图可以看得出来，<strong>通用TIM是包含了基本TIM的功能</strong>。也可以说基本定时器是定时器最基本的计数部分，我们该文主要就是围绕这部分来讲述，后续会其他更通用、高级的功能给大家讲述。</p>
<p><strong>重要的几个参数（信息）：</strong></p>
<p><strong>1.CK_INT时钟</strong>：一般由RCC提供（注意：其频率大部分都是系统时钟的一半，在程序中有一个除2的部分，详情请见RCC部分）。</p>
<p><strong>2.CK_PSC时钟预分频</strong>：也就是对<strong>CK_INT</strong>分频。这个值范围：0 - 65535范围都可以，最好能被<strong>CK_INT</strong>除尽，这样才方便计算时钟。</p>
<p><strong>3.ARR重载值</strong>：这个值相当于是我们设定需要计数的值，也就是说计数到这个设定值就会产生一个事件。</p>
<p><strong>综上</strong>： <strong>CK_INT</strong>和<strong>CK_PSC</strong>确定计数的时钟频率（1秒计多少数）， <strong>ARR</strong>是设定的计数值。最基本的延时（或定时）就由以上三个参数计算而来。</p>
<p><strong>Ⅳ、</strong><strong>基本延时源代码分析</strong></p>
<p>笔者以F4标准外设库（同时也建议初学者使用官方的标准外设库）为建立的工程，主要以库的方式来讲述。</p>
<p>考虑大家到以后肯定使用定时器更多功能，笔者提供的软件工程实例是<strong>通用定时TIM4</strong>。其实，将工程中<strong>TIM4改为TIM6</strong>(基本定时器)一样可以运行的。</p>
<p><strong>1.RCC时钟</strong></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/957778/201607/957778-20160708115849139-944390848.png" /></p>
<p>该函数位于bsp.c文件下面；</p>
<p><strong>重点注意：</strong></p>
<p>A.外设RCC时钟的配置要在其外设初始化的前面；</p>
<p>B.匹配对应时钟。</p>
<p>比如：RCC_APB2外设不要配置在RCC_APB1时钟里面</p>
<p>【如：RCC_APB1PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);这样能编译通过，但这是错误的代码】</p>
<p><strong>2.TIM配置</strong></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/957778/201607/957778-20160708115912811-879536590.png" /></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/957778/201607/957778-20160708115920483-1971577584.png" /></p>
<p>该函数位于timer.c文件下面；</p>
<p>该函数就是配置定时器基本计数的函数；</p>
<p><strong>配置为1us的基准：</strong></p>
<p><strong>A.1秒钟计数42M次个脉冲</strong></p>
<p>&ldquo;TIM基本延时&rdquo;实例工程中：<strong>CK_INT = 84M时钟</strong>（SystemCoreClock/2）</p>
<p>&ldquo;TIM基本延时&rdquo;实例工程：<strong>CK_PSC =&nbsp;</strong>84M/42M - 1 = 1 &nbsp;即2分频；</p>
<p><strong>至于为什么要减1？ </strong></p>
<p>初学者可以理解为&ldquo;<strong>CK_PSC = 0&rdquo;</strong>时不分频（即1分频）；&ldquo;<strong>CK_PSC = 1&rdquo;</strong>时为2分频。</p>
<p><strong>#define TIM4_COUNTER_CLOCK &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;42000000</strong></p>
<p><strong>#define</strong><strong>&nbsp;</strong><strong>TIM4_PRESCALER_VALUE &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(SystemCoreClock/2/TIM4_COUNTER_CLOCK - 1)</strong></p>
<p><strong>B.1</strong><strong>秒钟</strong><strong>计数1M次个周期</strong></p>
<p><strong>#define TIM4_PERIOD_TIMING &nbsp;&nbsp;&nbsp;(42 - 1)</strong></p>
<p>即ARR重载值；</p>
<p>由上面&ldquo;<strong>A</strong>&rdquo;得出&ldquo;1秒钟计数42M次个脉冲&rdquo;，则记满42个脉冲数需要1us(也就是1秒钟计数1M次个周期)。</p>
<p><strong>&nbsp;</strong></p>
<p><strong>3.us(微妙)延时函数</strong></p>
<p><strong><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/957778/201607/957778-20160708120319842-1597654715.png" /></strong></p>
<p>该函数位于timer.c文件下面；</p>
<p>上图一个while循环就是1us的时间；上面的一些工作就是配置定时器工作一个周期的时间为1us，这里延时N微妙就应该很好理解了； 其实还有一个函数延时N毫秒，很简单，不描述。</p>
<p><strong>Ⅴ、</strong><strong>定时中断</strong><strong>（拓展）</strong></p>
<p>&ldquo;定时中断&rdquo;功能是基于前面基础上进行了一个拓展，增加了计数周期就中断的功能。</p>
<p>笔者单独提供了一个实例：定时1ms中断一次（两工程区别在于时间不是1us， 1us中断一次时间太短）；</p>
<p>在软件上主要就是增加开启TIM中断、配置NVIC、添加TIM中断函数；</p>
<p><strong>1.使能TIM中断</strong></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/957778/201607/957778-20160708120339436-422891846.png" /></p>
<p>该函数位于（定时中断工程）timer.c文件下面；</p>
<p>功能：使能TIM中断。</p>
<p><strong>2.配置NVIC中断控制器</strong></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/957778/201607/957778-20160708120355717-332579381.png" /></p>
<p>该函数位于（定时中断工程）bsp.c文件下面；</p>
<p>功能：配置TIM中断控制。</p>
<p><strong>3.中断函数</strong></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/957778/201607/957778-20160708120405780-598318230.png" /></p>
<p>该函数位于（定时中断工程）stm32f4xx_it.c文件下面；</p>
<p>功能：定时周期到进入该中断函数。其中有一个计数减，相当于我们延时工程中while延时N的值;</p>
<p><strong>Ⅵ、</strong><strong>说明</strong></p>
<p>关于笔者提供的软件工程实例，可关注微信，在会话框回复&ldquo;关于工程&rdquo;，有关于工程结构描述、型号修改等讲述。</p>
<p>以上总结仅供参考，若有不对之处，敬请谅解。</p>
<p><strong>Ⅶ、</strong><strong>最后</strong></p>
<p>更多精彩文章我讲第一时间在微信公众号里面分享。</p>
<p>本着免费分享的原则，方便大家手机学习知识，定期在微信平台分享技术知识。如果你觉得分享的内容对你有用，又想了解更多相关的文章，请用微信搜索&ldquo;EmbeddDeveloper&rdquo; 或者扫描下面二维码、关注，将有更多精彩内容等着你。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/957778/201607/957778-20160708115722592-1877083022.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/957778/201607/957778-20160708115732030-2002125694.gif" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqd4kxqd.html">Properties操作指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96pdnj8.html">TFS API &colon; 四、工作项查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql1ye19.html">JavaScript零基础学习系列一</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvd0vxq.html">Ubuntu 12&sol;14 个性化配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e30nxq.html">配置nginx负载均衡</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kkd038.html">Cannot refer to an instance field pageTitle while explicitly invoking a cons</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwpjjy8.html">PHP数据库操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qne2dgq.html">手机上的页面转换page slider</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zz30x8.html">Ubuntu-12&period;04-server 配置修改静态 IP地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4x1258.html">ubuntu apt-get 总结 install xxx -d能下载安装包（含依赖）不安装&lowbar;和卸载（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1jypx9.html">简单的C&num;线程开发实例&lpar;隔一秒改变一下Label的Text&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okrp759.html">SQL&colon;42601</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmyw0e9.html">C的陷阱和缺陷研读笔记02</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o6l1j9.html">codeforces 377B  Preparing for the Contest   二分&plus;优先队列</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4znv6e9.html">aps&period;net验证控件的异常处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z6gk59.html">JAVA8新特性（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpwdw59.html">Flask Web中文教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwkx5v9.html">PowerBI更新 - 解决方案架构 - PowerBI Solution Architecture（一图胜万字！）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9602gvy9.html">Redis深入之对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1mrnlq.html">python学习之----BeautifulSoup示例二</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j01374q.html">部署windows服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1j7xj9.html">T4 assembly</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjwrl49.html">&amp;amp&semi;amp&semi; replace &amp;amp&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yjlgjq.html">菜鸟-手把手教你把Acegi应用到实际项目中&lpar;7&rpar;-缓存用户信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j01weeq.html">结束日期必须大于开始日期－－My97DatePicker日历控制的又一方便之处</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xw5jr9.html">【CImg】简单的畸变矩形矫正</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydypomq.html">高校应该使用 Drupal 的10大理由</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zreo49.html">Win2D 官方文章系列翻译 - 避免内存泄漏</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mop3xq.html">安装Oracle软件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydvdd2q.html">No&period;009 Palindrome Number</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
